{------------------------------------------------------------------------------}
{   About.pas                                                                  }
{                                                                              }
{   Copyright (c) 2001 by Pascal de Bruijn                                     }
{   All rights reserved worldwide                                              }
{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }
{------------------------------------------------------------------------------}

unit About;

{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ProUrl, ComCtrls, ProCtrls, Gauges, Menus;

type
  TAboutForm = class(TForm)
    IconProImage: TProImage;
    TitleProLabel: TProLabel;
    CopyrightProLabel: TProLabel;
    ProBorder1: TProBorder;
    WebsiteProLabel: TProLabel;
    EmailProLabel: TProLabel;
    WebsiteProUrlLabel: TProUrlLabel;
    EmailProUrlLabel: TProUrlLabel;
    OKProButton: TProButton;
    ThanksProLabel1: TProLabel;
    DownLeftProSpeedButton: TProSpeedButton;
    DownRightProSpeedButton: TProSpeedButton;
    SystemProgressBar: TProgressBar;
    GDIProgressBar: TProgressBar;
    UserProgressBar: TProgressBar;
    SystemProLabel: TProLabel;
    GDIProLabel: TProLabel;
    UserProLabel: TProLabel;
    ProBorder2: TProBorder;
    ThanksProLabel2: TProLabel;
    VersionProLabel: TProLabel;
    ThanksProLabel3: TProLabel;
    PoweredProUrlImage: TProUrlImage;
    procedure OKProButtonClick(Sender: TObject);
    procedure DownProSpeedButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    EasterEggEnabled: Boolean;
  public
    { Public declarations }
  end;

{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

function GetFreeSystemResources(Mode: Integer): Integer;
var
  _MyGetFreeSystemResources32: function(Mode: Integer): Integer stdcall;
  RSRC32DLL: THandle;
begin
  Result := 100;
  RSRC32DLL := LoadLibrary('RSRC32.DLL');
  if (RSRC32DLL <> 0) then
  begin
    @_MyGetFreeSystemResources32 := GetProcAddress(RSRC32DLL, '_MyGetFreeSystemResources32@4');
    Result := _MyGetFreeSystemResources32(Mode);
    FreeLibrary(RSRC32DLL);
  end;
end; { GetFreeSystemResources }

{------------------------------------------------------------------------------}

procedure TAboutForm.OKProButtonClick(Sender: TObject);
begin
  Close;
end; { OKProButtonClick }

{------------------------------------------------------------------------------}

procedure TAboutForm.DownProSpeedButtonClick(Sender: TObject);
begin
  SystemProgressBar.Position := GetFreeSystemResources(0);
  GDIProgressBar.Position := GetFreeSystemResources(1);
  UserProgressBar.Position := GetFreeSystemResources(2);
  DownLeftProSpeedButton.Visible := False;
  DownRightProSpeedButton.Visible := False;
  Top := Top - 56;
  ClientHeight := 377;
end; { DownProSpeedButtonClick }

{------------------------------------------------------------------------------}

procedure TAboutForm.FormShow(Sender: TObject);
begin
  EasterEggEnabled := False;
end; { FormShow }

{------------------------------------------------------------------------------}

end. { About }



