{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }

unit FileName;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs;

type
  TFileNameForm = class(TForm)
    OpenPictureDialog: TOpenPictureDialog;
    FileNameEdit: TEdit;
    OKButton: TButton;
    CancelButton: TButton;
    BrowseButton: TButton;
    RelativeCheckBox: TCheckBox;
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure BrowseButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    OKClicked: Boolean;
    FileName: string;
    RelativePath: string;
  end;

var
  FileNameForm: TFileNameForm;

implementation

{$R *.dfm}

procedure TFileNameForm.OKButtonClick(Sender: TObject);
begin
  if RelativeCheckBox.Checked then
    FileName := ExtractRelativePath(RelativePath, ExpandFileName(FileNameEdit.Text))
  else
    FileName := ExpandFileName(FileNameEdit.Text);
  OKClicked := True;
  Close;
end;

procedure TFileNameForm.CancelButtonClick(Sender: TObject);
begin
  FileName := '';
  OKClicked := False;
  Close;
end;

procedure TFileNameForm.BrowseButtonClick(Sender: TObject);
begin
  OpenPictureDialog.FileName := FileNameEdit.Text;
  if OpenPictureDialog.Execute then
  begin
    FileNameEdit.Text := OpenPictureDialog.FileName;
  end;
end;

end.
