{------------------------------------------------------------------------------}
{   GoToLine.pas                                                               }
{                                                                              }
{   Copyright (c) 2001 by Pascal de Bruijn                                     }
{   All rights reserved worldwide                                              }
{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }
{------------------------------------------------------------------------------}

unit GoToLine;

{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TLineForm = class(TForm)
    OKButton: TButton;
    CancelButton: TButton;
    LineSpinEdit: TSpinEdit;
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
    ClickedOK: Boolean;
    SelectedLine: LongInt;
    MaxLine: LongInt;
  end;

{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

procedure TLineForm.OKButtonClick(Sender: TObject);
begin
  SelectedLine := LineSpinEdit.Value;
  ClickedOK := True;
  Close;
end; { OKButtonClick }

{------------------------------------------------------------------------------}

procedure TLineForm.CancelButtonClick(Sender: TObject);
begin
  ClickedOK := False;
  Close;
end; { CancelButtonClick }

{------------------------------------------------------------------------------}

procedure TLineForm.FormShow(Sender: TObject);
begin
  ClickedOK := False;
  LineSpinEdit.MaxValue := MaxLine;
  LineSpinEdit.SetFocus;
end; { FormShow }

{------------------------------------------------------------------------------}

procedure TLineForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Shift = [] then
  begin
    case Key of
      VK_RETURN:
      begin
        OKButton.SetFocus;
        OKButton.Click;
      end;
      VK_ESCAPE:
      begin
        CancelButton.SetFocus;
        CancelButton.Click;
      end;
    end;
  end;
end; { FormKeyDown }

{------------------------------------------------------------------------------}

end. { GoToLine }
