!packhdr tmp.dat "upx --best tmp.dat"


OutFile "Install.exe"
Name "JSourcEd"
Caption "JSourcEd Installer"
CRCCheck On

InstallDir $PROGRAMFILES\JSourcEd
InstallDirRegKey HKLM SOFTWARE\JSourcEd "InstallDir"

LicenseText "Please carefully read the following license agreement before installing JSourcEd onto your system:"
LicenseData License.txt

ComponentText "This will install JSourcEd onto your system. Please select which options you want installed:"
InstType "Typical (Student)"
InstType "Full (Teacher)"

DirText "Please select a directory to install JSourcEd in to:"

InstProgressFlags smooth
CompletedText "Succesfully completed JSourcEd's installation!"

UninstallText "This will uninstall JSourcEd. Click UnInstall to continue."
UninstallCaption "JSourcEd UnInstaller"
UninstallButtonText "UnInstall"

Section "JSourcEd (required)"
  SectionIn 1 2
  SetOutPath "$INSTDIR"
  File "\JSourcEd\JSourcEd.exe"
  File "\JSourcEd\JSourcEd.ref"
  File "\JSourcEd\JSourcEd.lst"
  WriteRegStr HKLM "SOFTWARE\JSourcEd" "InstallDir" "$INSTDIR"
  WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\JSourcEd" "DisplayName" "JSourcEd (remove only)"
  WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\JSourcEd" "UninstallString" '"$INSTDIR\UnInstall.exe"'
  WriteINIStr "$INSTDIR\JSourcEd.ini" "License" "Accepted" "264"
  WriteUninstaller "$INSTDIR\UnInstall.exe"
SectionEnd

SectionDivider

Section "Advanced Configuration Tool"
  SectionIn 2
  SetOutPath "$INSTDIR"
  File "\JSourcEd\AdvCfgTl.exe"
SectionEnd

Section "MakeRef"
  SectionIn 2
  SetOutPath "$INSTDIR"
  File "\JSourcEd\RefEdit.exe"
SectionEnd

SectionDivider

Section "Start Menu Shortcuts"
  SectionIn 1 2
  AddSize 4
  CreateDirectory "$SMPROGRAMS\JSourcEd"
  CreateShortCut "$SMPROGRAMS\JSourcEd\JSourcEd.lnk" "$INSTDIR\JSourcEd.exe" "" "$INSTDIR\JSourcEd.exe" 0
  IfFileExists "$INSTDIR\AdvCfgTl.exe" do1 next1
do1:
  CreateShortCut "$SMPROGRAMS\JSourcEd\Advanced Configuration Tool.lnk" "$INSTDIR\AdvCfgTl.exe" "" "$INSTDIR\AdvCfgTl.exe" 0
next1:
  IfFileExists "$INSTDIR\RefEdit.exe" do2 next2
do2:
  CreateShortCut "$SMPROGRAMS\JSourcEd\RefEdit.lnk" "$INSTDIR\RefEdit.exe" "" "$INSTDIR\RefEdit.exe" 0
next2:
  CreateShortCut "$SMPROGRAMS\JSourcEd\UnInstall.lnk" "$INSTDIR\UnInstall.exe" "" "$INSTDIR\UnInstall.exe" 0
SectionEnd

Section "Desktop Shortcut"
  SectionIn 1 2
  AddSize 1
  CreateShortCut "$DESKTOP\JSourcEd.lnk" "$INSTDIR\JSourcEd.exe" "" "$INSTDIR\JSourcEd.exe" 0
SectionEnd

Section "UnInstall"
  DeleteRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\JSourcEd"
  DeleteRegKey HKLM SOFTWARE\JSourcEd
  Delete $INSTDIR\JSourcEd.exe
  Delete $INSTDIR\JSourcEd.ref
  Delete $INSTDIR\JSourcEd.lst
  Delete $INSTDIR\JSourcEd.ini
  Delete $INSTDIR\AdvCfgTl.exe
  Delete $INSTDIR\RefEdit.exe
  Delete $INSTDIR\UnInstall.exe
  Delete "$SMPROGRAMS\JSourcEd\JSourcEd.lnk"
  Delete "$SMPROGRAMS\JSourcEd\Advanced Configuration Tool.lnk"
  Delete "$SMPROGRAMS\JSourcEd\RefEdit.lnk"
  Delete "$SMPROGRAMS\JSourcEd\UnInstall.lnk"
  Delete "$DESKTOP\JSourcEd.lnk"
  RMDir "$INSTDIR"
  RMDir "$SMPROGRAMS\JSourcEd"
SectionEnd

Function .onUserAbort
    MessageBox MB_YESNO "Abort installation?" IDYES NoCancelAbort
      Abort
    NoCancelAbort:
FunctionEnd

Function un.onUserAbort
  MessageBox MB_YESNO "Abort uninstallation?" IDYES NoCancelAbort
    Abort
  NoCancelAbort:
FunctionEnd