{------------------------------------------------------------------------------}
{   JarMaker.pas                                                               }
{                                                                              }
{   Copyright (c) 2001 by Pascal de Bruijn                                     }
{   All rights reserved worldwide                                              }
{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }
{------------------------------------------------------------------------------}

unit JarMaker;

{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ProCtrls, ProDlgs;

type
  TMakerForm = class(TForm)
    ClassProListBox: TProListBox;
    AddButton: TButton;
    RemoveButton: TButton;
    MakeJarButton: TButton;
    CloseButton: TButton;
    OpenDialog: TOpenDialog;
    ProStopDialog: TProStopDialog;
    RemoveAllButton: TButton;
    procedure AddButtonClick(Sender: TObject);
    procedure RemoveButtonClick(Sender: TObject);
    procedure MakeJarButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure RemoveAllButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    JarPath: string;
  end;

{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

procedure TMakerForm.AddButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    ClassProListBox.Items.Add(OpenDialog.FileName);
  end;
end; { AddButtonClick }

{------------------------------------------------------------------------------}

procedure TMakerForm.RemoveButtonClick(Sender: TObject);
begin
  if ClassProListBox.ItemIndex > -1 then
  begin
    ClassProListBox.Items.Delete(ClassProListBox.ItemIndex);
  end;
end; { RemoveButtonClick }

{------------------------------------------------------------------------------}

procedure TMakerForm.MakeJarButtonClick(Sender: TObject);
var
  StartupInfo                         : TStartupInfo;
  ProcessInformation                  : TProcessInformation;
  I                                   : LongInt;
  Files                               : string;
  Jar                                 : string;

begin
  if ClassProListBox.Items.Count > 0 then
  begin
    if InputQuery('Jar Name', 'Please enter the jar''s name:', Jar) then
    begin
      Application.ProcessMessages;
      Jar := ChangeFileExt(Jar, '.jar');
      Files := '';
      for I := 0 to Pred(ClassProListBox.Items.Count) do
      begin
        Files := ' ' + ClassProListBox.Items[I];
      end;
      GetStartupInfo(StartupInfo);
      StartupInfo.dwFlags := STARTF_USESHOWWINDOW or STARTF_FORCEONFEEDBACK;
      StartupInfo.wShowWindow := SW_SHOWNORMAL;
      CreateProcess(nil, PChar(ExtractFilePath(JarPath) + '\JAR.EXE cvf ' + Jar + Files), nil, nil, False, NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInformation);
      Application.ProcessMessages;
    end;
  end
  else
  begin
    ProStopDialog.StopMessage := 'Please specify classes first!';
    ProStopDialog.Execute;
  end;
end; { MakeJarButtonClick }

{------------------------------------------------------------------------------}

procedure TMakerForm.CloseButtonClick(Sender: TObject);
begin
  Close;
end; { CloseButtonClick }

{------------------------------------------------------------------------------}

procedure TMakerForm.RemoveAllButtonClick(Sender: TObject);
begin
  ClassProListBox.Items.Clear;
end; { RemoveAlButtonClick }

{------------------------------------------------------------------------------}

end. { JarMaker }
