{------------------------------------------------------------------------------}
{   Splash.pas                                                                 }
{                                                                              }
{   Copyright (c) 2001 by Pascal de Bruijn                                     }
{   All rights reserved worldwide                                              }
{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }
{------------------------------------------------------------------------------}

unit Splash;

{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, CRC32;

type
  TSplashForm = class(TForm)
    SplashImage: TImage;
    procedure FormDeactivate(Sender: TObject);
    procedure SplashImageClick(Sender: TObject);
  private
    { Private declarations }
    StartTime: Cardinal;
    OldFileMode: Byte;
    F: file;
    BytesRead: Integer;
    Checksum: LongInt;
    Buffer: array[1..4096] of Byte;
    Appendage: array[1..4] of LongInt;
    Wait: Boolean;
  public
    { Public declarations }
  end;

var
  SplashForm: TSplashForm;
  I: Integer;

{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

procedure TSplashForm.FormDeactivate(Sender: TObject);
begin
  if Wait then
  begin
    repeat
      Application.ProcessMessages;
    until ((GetTickCount - StartTime) > 1000) or (GetTickCount < StartTime) or (not Wait);
  end;
  Hide;
  Release;
end; { FormDeactivate }

{------------------------------------------------------------------------------}

procedure TSplashForm.SplashImageClick(Sender: TObject);
begin
  Wait := False;
end; { SplashImageClick }

{------------------------------------------------------------------------------}

initialization
  SplashForm := TSplashForm.Create(nil);
  SplashForm.Show;
  SplashForm.Update;

  with SplashForm do
  begin
    StartTime := GetTickCount;

    Wait := True;

    OldFileMode := FileMode;
    FileMode := {ReadOnly} 0;

    AssignFile(F, Application.ExeName);
    try
      ReSet(F, 1);
      Seek(F, FileSize(F) - SizeOf(Appendage));
      BlockRead(F, Appendage, SizeOf(Appendage));
      if (Appendage[1] <> $53435641) or (Appendage[4] <> $53435641) then
      begin
        ShowMessage('WARNING: Anti-Virus Checksum Stamp missing!' + #13 +
                    'This program might be infected with a virus,' + #13 +
                    'please install a new version of JSourcEd!');
        Application.Terminate;
        Exit;
      end;
      if FileSize(F) <> Appendage[2] then
      begin
        ShowMessage('WARNING: Incorrect file size!' + #13 +
                    'This program might be infected with a virus,' + #13 +
                    'please install a new version of JSourcEd!');
        Application.Terminate;
        Exit;
      end;
      Seek(F, 0);
      InitCRC32(Checksum);
      repeat
        BlockRead(F, Buffer, SizeOf(Buffer), BytesRead);
        if FilePos(F) >= FileSize(F) - SizeOf(Appendage) then
        begin
          BytesRead := BytesRead - (SizeOf(Appendage) - (FileSize(F) - FilePos(F)))
        end;

        if BytesRead > 0 then
        begin
          for I := 1 to BytesRead do UpdateCRC32(Checksum, Buffer[I]);
        end;
      until BytesRead <> SizeOf(Buffer);
      FinishCRC32(Checksum);
      FileMode := OldFileMode;
      if Appendage[3] <> Checksum then
      begin
        ShowMessage('WARNING: Incorrect checksum!' + #13 +
                    'This program might be infected with a virus,' + #13 +
                    'please install a new version of JSourcEd!');
        Application.Terminate;
        Exit;
      end;
    finally
      CloseFile(F);
    end;
  end;
end. { Splash }
