program StampCRC;

uses
  CRC32 in 'crc32.pas';

const
  Stamp = $53435641;

var
  F: file;
  BytesRead, I: Integer;
  Buffer: array[1..4096] of Byte;
  Appendage: array[1..4] of LongInt;

begin
  WriteLn('StampCRC [32] v3 - Copyright 2001 by Pascal de Bruijn');
  WriteLn;
  Write('Please wait, calculating stamp for ', ParamStr(1), '...');
  {$I-}
  AssignFile(F, ParamStr(1));
  ReSet(F, 1);
  if IOResult <> 0 then
  begin
    WriteLn('Error!');
    WriteLn;
    WriteLn('File not found');
    Halt;
  end;
  {$I+}
  Seek(F, FileSize(F) - SizeOf(Appendage));
  BlockRead(F, Appendage, SizeOf(Appendage));
  if (Appendage[1] = Stamp) and (Appendage[4] = Stamp) then
  begin
    WriteLn('Already stamped!');
    Halt;
  end;
  Seek(F, 0);
  Appendage[1] := Stamp;
  Appendage[4] := Stamp;
  InitCRC32(Appendage[3]);
  repeat
    BlockRead(F, Buffer, SizeOf(Buffer), BytesRead);
    for I := 1 to BytesRead do UpdateCRC32(Appendage[3], Buffer[I]);
    Write('.');
  until Eof(F);
  FinishCRC32(Appendage[3]);
  WriteLn('Ok!');
  Appendage[2] := FileSize(F) + SizeOf(Appendage);
  Write('Please wait, imprinting stamp on ', ParamStr(1), '...');
  BlockWrite(F, Appendage, SizeOf(Appendage));
  WriteLn('Ok!');
  CloseFile(F);
end.
