{------------------------------------------------------------------------------}
{   Summary.pas                                                                }
{                                                                              }
{   Copyright (c) 2001 by Pascal de Bruijn                                     }
{   All rights reserved worldwide                                              }
{                                                                              }
{   JSourcEd is distributed on a GPL license                                   }
{   (http://www.gnu.org/copyleft/gpl.html).                                    }
{                                                                              }
{------------------------------------------------------------------------------}

unit Summary;

{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ProCtrls;

type
  TSummaryForm = class(TForm)
    OKButton: TButton;
    GoToButton: TButton;
    ProListBox: TProListBox;
    procedure OKButtonClick(Sender: TObject);
    procedure GoToButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    WhichLine: LongInt;
    LineNo: TStringList;
  end;

{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}

{$R *.DFM}

{------------------------------------------------------------------------------}

procedure TSummaryForm.OKButtonClick(Sender: TObject);
begin
  WhichLine := -1;
  Close;
end; { OKButtonClick }

{------------------------------------------------------------------------------}

procedure TSummaryForm.GoToButtonClick(Sender: TObject);
begin
  if (ProListBox.ItemIndex >= 0) and (ProListBox.ItemIndex < ProListBox.Items.Count) then
  begin
    WhichLine := StrToInt(LineNo.Strings[ProListBox.ItemIndex]);
    Close;
  end;
end; { GoToButtonClick }

{------------------------------------------------------------------------------}

procedure TSummaryForm.FormCreate(Sender: TObject);
begin
  LineNo := TStringList.Create;
end; { FormCreate }

{------------------------------------------------------------------------------}

procedure TSummaryForm.FormDestroy(Sender: TObject);
begin
  LineNo.Free;
end; { FormDestroy }

{------------------------------------------------------------------------------}

procedure TSummaryForm.FormShow(Sender: TObject);
begin
  WhichLine := -1;
end; { FormShow }

{------------------------------------------------------------------------------}

end. { Explorer }
